#include <iostream>
#include <fstream>
#include <cassert>
#define NN 1500
#define MM 64
using namespace std;

ifstream fin("plus.in");
ofstream fout("plus.out");

typedef unsigned char NrMare[MM];

NrMare  stiva[NN];
int n, nrs;

int NrMareCmp(NrMare a, NrMare b){
	// daca a<b => -1
	// daca a>b =>  1
	// daca a=b => 0
	if( a[0] > b[0] )
		return 1;
	if( a[0] < b[0] )
		return -1;
	int i=a[0];
	while( i>0 && a[i]==b[i] )
		--i;
	if( i == 0 )
		return 0;
	return ( a[i]<b[i] ) ? -1 : 1;
}

void Atrib(NrMare x, int a){
	x[0] = 0;
	do
		x[++x[0]] = a % 10 , a /= 10;
	while(a);
}

void Atrib(NrMare d, NrMare s){
	for( int i=0 ; i<=s[0] ; ++i )
		d[i] = s[i];

}

void Afis(ostream &out, NrMare x, bool ENDL=true){
	for(int i = x[0] ; i ; --i)
		out << (int)x[i] ;
	if(ENDL)
		out << endl;
	else
		out << " ";
}

void Plus(NrMare nm1, NrMare nm2, NrMare sol){
	sol[ sol[0]=1 ] = 0;
	int pc = 0 ; // numarul de pozitii comune
	NrMare c;
	unsigned char *x , *y;
	for( int ttt=0 ; ttt<2 ; ++ttt ){
		if( ttt )
			x = nm2, y = nm1;
		else
			x = nm1, y = nm2;
		for( int i=y[0] ; i>0 ; --i )
		{
			int nrpc = 0;
			for( int j=1, k=i ; j<=x[0] && k<=y[0] ; ++j, ++k ){
				if( x[j]==y[k] )
					++ nrpc;
			}
			if( nrpc > 0 && nrpc >= pc ){
				int t = 0 , tmp;
				c[0]=0;
				for( int j=1 ; j<i ; ++j ){
					tmp = y[j]+t;
					++c[0];
					assert(c[0] < MM);
					c[c[0]]= tmp % 10;
					t = tmp /10;
				}
				int j , k;
				for( j=1 , k=i; j<=x[0] && k<=y[0] ; ++j , ++k )
					if(x[j]!=y[k]){
						tmp = x[j]+y[k]+t;
						++c[0];
						assert(c[0] < MM);
						c[c[0]]= tmp % 10;
						t = tmp /10;
					}
				while( j<=x[0] ){
						tmp = x[j]+t;
						++c[0];
						assert(c[0] < MM);
						c[c[0]]= tmp % 10;
						t = tmp /10;
						j++;
					}
				while( k<=y[0] ){
						tmp = y[k]+t;
						++c[0];
						assert(c[0] < MM);
						c[c[0]]= tmp % 10;
						t = tmp /10;
						k++;
					}
				while( t ){
						++c[0];
						assert(c[0] < MM);
						c[c[0]]= t % 10 , t = t /10;
				}
				if( nrpc>pc )
					Atrib(sol,c),  pc = nrpc;
				else
					if(NrMareCmp(sol,c)<0)
						Atrib(sol,c);
			}
		}
	}
	if(pc==0)
		Atrib(sol,0);

}

int main(){
	fin >> n;
	assert( 1 < n && n <= 2000 );
	int adancime_maxima=0;
	NrMare a,b;
	nrs = 0;
	for(int i=1;i<=n;++i){
		int x;
		fin >> x;
		assert(x>=-2 && x<=1000000000);
		if(x==-1){
			nrs++;
			if(nrs > adancime_maxima)
				adancime_maxima = nrs;
			stiva[nrs][0]=0;
		}
		if(x>=0){
			if(stiva[nrs][0]==0)
				Atrib(stiva[nrs],x);
			else{
				Atrib(a,stiva[nrs]);
				Atrib(b,x);
				Plus(a,b,stiva[nrs]);
			}
		}
		if(x==-2){
			Atrib(a,stiva[nrs]);
			nrs--;
			assert(nrs >= 0);
			if(stiva[nrs][0]==0)
				Atrib(stiva[nrs],a);
			else{
				Atrib(b,stiva[nrs]);
				Plus(a,b,stiva[nrs]);
			}
		}
	}
	fout << adancime_maxima << "\n";
	Afis(fout, stiva[nrs]);
	return 0;
}
