/*
    Solutie 50 p
    recursiv
    stud. Marius Stroe
*/
#include <cstdio>
#include <cassert>
#include <algorithm>
using namespace std;

const char iname[] = "poly.in";
const char oname[] = "poly.out";

typedef long long i64;

const int MAX_N = 1 << 16;
const i64 Modulo = 30103;

int n;


int main(void) {
    FILE *fi = fopen(iname, "r");
    assert(fscanf(fi, "%d", &n) == 1);
    assert(2 <= n && n <= 15000);
    fclose(fi);

    i64 C[MAX_N];

    C[0] = 1;

    for (int i = 0; i < n; ++ i) {
        C[i + 1] = 0;
        for (int j = 0; j <= i; ++ j)
            C[i + 1] = (C[i + 1] + C[j] * C[i - j]) % Modulo;
    }

    fprintf(fopen(oname, "w"), "%lld\n", C[n]);

    return 0;
}
