# include <cstdio>
# include <cstring>
# define M 30103

int N, i;
unsigned long long C[15001];

/*
Catalan(n) = Catalan(0)*Catalan(n-1) +
             Catalan(1)*Catalan(n-2) +
             Catalan(2)*Catalan(n-3) +
             ...                     +
       int catalan(int N)
*/
int catalan(int N)
{
    int i, j;
    memset(C, 0, sizeof(C));
    C[0] = (unsigned long long) 1;
    for (i=1; i<=N; ++i)
        for (j=0; j<i; ++j)
            C[i] = (C[i] % M + (C[j]*C[i-j-1]) % M) % M;
    return C[N];
}

int main()
{
	freopen("poly.in","r",stdin);
	freopen("poly.out","w",stdout);

	scanf("%d",&N);
    printf("%d\n", catalan(N));

	return 0;
}

