/*
    Solutie 60 p

    calc.combinari folosind triunghiul lui Pascal

    prof. Eugen Nodea
*/

# include <cstdio>
# include <cstring>
# define M 30103
# define nmax 1001

int c[nmax][nmax], N;

int catalan_(int N)
{
    int i,j;
    //C(n) = Comb(2n, n) - Comb(2n, n-1)
    // calcul combinari folosind triunghiul lui Pascal
    c[0][0] =  1;
    c[1][1] =  1;
    for (i = 2; i<=2 * N; ++i)
        for (j=1; j<= N; ++j)
            c[i][j] = (c[i-1][j] % M + c[i-1][j-1] % M);
    return (int)(c[2 * N][N] % M - c[2 * N][N-1] % M) % M ;
}

int main()
{
	freopen("poly.in","r",stdin);
	freopen("poly.out","w",stdout);

	scanf("%d",&N);
    printf("%d\n",catalan_(N));

	return 0;
}
